


#stage 0, prep teleport mark current location and mark the targeted location
#target a random player
execute unless entity @a[tag=fancy_tp_use] if entity @e[type=armor_stand,tag=fancy_tp_target] run tag @s[tag=fancy_tp_move,tag=fancy_tp] add fancy_tp_use
execute unless entity @a[tag=fancy_tp_use] run tag @s[tag=fancy_tp_home,tag=fancy_tp] add fancy_tp_use
execute unless entity @a[tag=fancy_tp_use] run tag @s[tag=fancy_tp_return,tag=fancy_tp] add fancy_tp_use
execute as @s[tag=fancy_tp_use] run scoreboard players set @s fancy_tp_safe 0


#remove previous move_to and watch stand
execute as @e[type=armor_stand,tag=fancy_tp_watch_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use] fancy_tp_pl_id run kill @s
execute as @e[type=armor_stand,tag=fancy_tp_move_to] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use] fancy_tp_pl_id run kill @s


#save what gamemode the player is in
execute as @s[tag=fancy_tp_use,gamemode=survival] run tag @s add fancy_tp_survival
execute as @s[tag=fancy_tp_use,gamemode=adventure] run tag @s add fancy_tp_adventure
execute as @s[tag=fancy_tp_use,gamemode=creative] run tag @s add fancy_tp_creative
execute as @s[tag=fancy_tp_use,gamemode=spectator] run tag @s add fancy_tp_spectator
gamemode spectator @s[tag=fancy_tp_use,gamemode=adventure]


#mark the location the player should teleport to
#tp player return
execute if entity @s[tag=fancy_tp_return,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_return_stand] if score @s fancy_tp_en_id = @a[tag=fancy_tp_use,tag=fancy_tp_return,limit=1] fancy_tp_pl_id at @s run summon armor_stand ~ ~ ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,Small:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["fancy_tp_move_to_prep","fancy_tp_move_to","fancy_tp_forceload"]}
execute if entity @s[tag=fancy_tp_return,tag=fancy_tp_use] run scoreboard players operation @e[tag=fancy_tp_move_to_prep,type=armor_stand] fancy_tp_en_id = @a[tag=fancy_tp_use,tag=fancy_tp_return,limit=1] fancy_tp_pl_id
execute if entity @s[tag=fancy_tp_return,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] at @s run forceload add ~ ~
execute if entity @s[tag=fancy_tp_return,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] run tag @s remove fancy_tp_move_to_prep

#tp player home
execute at @s[tag=fancy_tp_home,tag=fancy_tp_use] run summon armor_stand ~ ~ ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,Small:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["fancy_tp_move_to_prep","fancy_tp_move_to","fancy_tp_forceload"]}
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] run scoreboard players operation @e[tag=fancy_tp_move_to_prep,type=armor_stand] fancy_tp_en_id = @a[tag=fancy_tp_use,tag=fancy_tp_home,limit=1] fancy_tp_pl_id
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] store result entity @e[type=minecraft:armor_stand,limit=1,tag=fancy_tp_move_to_prep] Pos[0] double 1 run data get entity @a[limit=1,tag=fancy_tp_use] SpawnX
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] store result entity @e[type=minecraft:armor_stand,limit=1,tag=fancy_tp_move_to_prep] Pos[1] double 1 run data get entity @a[limit=1,tag=fancy_tp_use] SpawnY
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] store result entity @e[type=minecraft:armor_stand,limit=1,tag=fancy_tp_move_to_prep] Pos[2] double 1 run data get entity @a[limit=1,tag=fancy_tp_use] SpawnZ
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] at @s if block ~ ~ ~ minecraft:bedrock run fill ~ 62 ~ ~ 62 ~ dirt replace air
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] at @s if block ~ ~ ~ minecraft:bedrock run fill ~ 63 ~ ~ 64 ~ air
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] at @s if block ~ ~ ~ minecraft:bedrock run tp @s ~ 63 ~
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] at @s run forceload add ~ ~
execute if entity @s[tag=fancy_tp_home,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] run tag @s remove fancy_tp_move_to_prep

#tp player move
execute if entity @s[tag=fancy_tp_move,tag=fancy_tp_use] at @e[type=armor_stand,tag=fancy_tp_target,limit=1] run summon armor_stand ~ ~ ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,Small:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["fancy_tp_move_to_prep","fancy_tp_move_to","fancy_tp_forceload"]}
execute if entity @s[tag=fancy_tp_move,tag=fancy_tp_use] run scoreboard players operation @e[tag=fancy_tp_move_to_prep,type=armor_stand] fancy_tp_en_id = @a[tag=fancy_tp_use,tag=fancy_tp_move,limit=1] fancy_tp_pl_id
execute if entity @s[tag=fancy_tp_move,tag=fancy_tp_use] run kill @e[type=armor_stand,tag=fancy_tp_target,limit=1]
execute if entity @s[tag=fancy_tp_move,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] at @s run forceload add ~ ~
execute if entity @s[tag=fancy_tp_move,tag=fancy_tp_use] as @e[type=armor_stand,tag=fancy_tp_move_to_prep] run tag @s remove fancy_tp_move_to_prep


#mark the players current location before teleporting if move
execute as @e[type=armor_stand,tag=fancy_tp_return_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use,tag=fancy_tp_move] fancy_tp_pl_id at @s unless entity @e[type=armor_stand,tag=fancy_tp_forceload,distance=0.1..22] run forceload remove ~ ~
execute as @e[type=armor_stand,tag=fancy_tp_return_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use,tag=fancy_tp_move] fancy_tp_pl_id run tp @s @a[limit=1,tag=fancy_tp_use,tag=fancy_tp_move]
execute as @e[type=armor_stand,tag=fancy_tp_return_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use,tag=fancy_tp_move] fancy_tp_pl_id at @s run forceload add ~ ~


#add tags and set stage score
scoreboard players set @s[tag=fancy_tp_move,tag=fancy_tp_use] fancy_tp_stage 1
scoreboard players set @s[tag=fancy_tp_return,tag=fancy_tp_use] fancy_tp_stage 1
scoreboard players set @s[tag=fancy_tp_home,tag=fancy_tp_use] fancy_tp_stage 1


#remove tags (run last)
tag @s[tag=fancy_tp_use] remove fancy_tp_move
tag @s[tag=fancy_tp_use] remove fancy_tp_home
tag @s[tag=fancy_tp_use] remove fancy_tp_return
tag @s remove fancy_tp_use